<template>
	<view class="order-detail">
		<zs-skeleton type="orderDetail" :loading="pageLoading"></zs-skeleton>
			<view class="status-box">
				<view class="text-box">
					<view class="status" v-if="info.goodsList[0].goodsState == 'WAIT_PAYMENT'&&!isNotTime">
						等待支付，剩余<u-count-down :time="closeTime" format="mm:ss" @finish="finish"></u-count-down>
					</view>
					<view class="status" v-else>
						{{info.goodsList[0] |filterType }}
					</view>
				</view>
			</view>

			<view class="content shop-box">
				<view class="shop-name">
					{{info.shopInfo.shopName}}
				</view>
				<view class="address">
					{{info.shopInfo.address}}
				</view>
			</view>
			
			<view class="content goods-box">
				<view class="title">
					订单信息
				</view>
				<view class="goods-item" v-for="(item,index) in info.goodsList[0].goodsInfo.products" :key="index">
					<view class="left">
						<image class="icon" :src="item.imageUrl" mode=""></image>
						<view class="name">
							{{item.nameCn}}
						</view>
						<view class="num">
							x{{item.quantity}}
						</view>
					</view>
					
					<view class="right">
						￥{{item.selPrice}}
					</view>
				</view>
				<view class="total-box">
					<view class="num">
						共{{info.goodsList[0].goodsInfo.products.length}}件 
					</view>
					<view class="price">
						小计￥{{info.payAmount}}
					</view>
				</view>
			</view>
			
			<view class="content code-box"  v-if="info.goodsList[0].goodsState == 'WAIT_USE'">
					<view class="title">
						券码信息
					</view>
					
					<uqrcode class="qrcode" ref="uqrcode" type="2d" auto canvas-id="qrcode" :value="codeData" :loading="loading" :options="{ margin: 20 }">
						 <template v-slot:loading>
							<text style="color: black;">拼命加载中...</text>
						  </template>
					</uqrcode>
			</view>
			
			
			<view class="content">
				<view class="item">
					<view class="label">
						联系号码
					</view>
					<view class="value">
						{{info.goodsList[0].goodsInfo.phone}}
					</view>
				</view>
				<view class="item">
					<view class="label">
						就餐方式
					</view>
					<view class="value">
						{{info.goodsList[0].goodsInfo.eatType == 0?'店内就餐':'打包带走'}}
					</view>
				</view>
				<view class="item">
					<view class="label">
						备注
					</view>
					<view class="value">
						{{info.goodsList[0].goodsInfo.remark ||'-'}}
					</view>
				</view>
			</view>
			
			<view class="content">
				<view class="title">
					订单信息
				</view>
				<view class="item">
					<view class="label">
						订单编号
					</view>
					<view class="value">
						{{info.orderNo}}
					</view>
				</view>
				
				<view class="item" v-if="info.goodsList[0].goodsState == 'WAIT_USE'">
					<view class="label">
						付款方式
					</view>
					<view class="value">
						{{info.payment | filterPay}}
					</view>
				</view>
				<view class="item">
					<view class="label">
						下单时间
					</view>
					<view class="value">
						{{$u.timeFormat(info.createTime,'yyyy-mm-dd hh:MM:ss')}}
					</view>
				</view>
				
				<view class="item" v-if="info.goodsList[0].goodsState != 'WAIT_PAYMENT' && info.goodsList[0].goodsState != 'CLOSE'">
					<view class="label">
						支付时间
					</view>
					<view class="value" >
						{{payTime}}
					</view>
				</view>
			</view>
	
			
			<view class="btn-box" v-if="info.goodsList[0].goodsState == 'WAIT_PAYMENT'">
				<button class="cancel-btn" @click="cancel" :loading="btnLoading">
					取消订单
				</button>
				<button class="btn" @click="pay" :loading="btnLoading">
					立即支付
				</button>
			</view>
		
	</view>
</template>

<script>
	import {qrCode,closeOrder} from '@/api/order.js'
	import {payDetails,queryPayOrder,unRefund,refundIntervene} from '@/api/payment.js';
	import {cancelOrder} from '@/api/refuel.js'
	export default {
		data() {
			return {
				codeData:'123',
				show:false,
				loading:false,
				pageLoading:true,
				btnLoading:false,
				btnLoading1:false,
				oldBright:0,
				info:{
					// goodsList:[{goodsState:'CLOSE'}]
				},
				isNotTime:false
			}
		},
		watch: {
			// isNotTime(val) {
			// 	if(this.isNotTime){
			// 		this.payDetails(this.info.orderNo)
			// 	}
			// }
		},
		filters: {
			filterType: function(val) {
				if(val.refundLog&&val.refundLog.refund == 'REFUSAL_REFUND'&&!val.change){
					return '拒绝退款'
				}
				else if(val.goodsState == 'APPLY_REFUND'){
					return '退款审核中'
				}else if(val.goodsState == 'CLOSE'){
					return '关闭订单'
				}else if(val.goodsState == 'REFUNDED'){
					return '已退款'
				}else if(val.goodsState == 'REFUSAL_REFUND'){
					return '拒绝退款'
				}else if(val.goodsState == 'APPLY_REFUNDING'){
					return '退款中'
				}else if(val.goodsState == 'USED'){
					return '订单已完成'
				}else if(val.goodsState == 'WAIT_PAYMENT'){
					return '待付款'
				}else if(val.goodsState == 'WAIT_USE'){
					return '待使用'
				}else{
					return ''
				}
			},
			filterPay(val){
				if(val){
					if(val.paymentWay == 'wx.unifiedOrder'){
						return '微信支付'
					}else if(val.paymentWay == 'trade.create'){
						return '支付宝支付'
					}else if(val.paymentWay == 'uac.miniOrder'){
						return '云闪付支付'
					}
				}
				else{
					return '-'
				}
			}
		},
		computed: {
			closeTime() {
				return (this.info.createTime + 1000*60*15) - new Date().getTime()
			},
			payTime(){
					if(this.info.payment && this.info.payment.paymentTime){
						return uni.$u.timeFormat(this.info.payment.paymentTime,'yyyy-mm-dd hh:MM:ss') 
					}else{
						return '-'
					}
			}
		},
		methods: {

			finish(){
				this.isNotTime = true
				this.payDetails(this.info.orderNo)
			},
			refundDetail(){
				uni.navigateTo({
					url:`/my/order/refundDetail?id=${this.info.orderNo}`
				})
			},
	
			close(){
				this.show = false
				// uni.setScreenBrightness({
				// 	value:this.oldBright
				// })
			},
			handleCall(){
				uni.makePhoneCall({
					phoneNumber: '4000016553'//仅为示例
				});
			},
			// 获取订单详情
			payDetails(orderNo){
				payDetails(orderNo).then(res=>{
					this.pageLoading = false
					this.info = res.content
		
					if(!this.info.goodsList[0].refundLog){
						this.info.goodsList[0].refundLog = {}
					}
					if(this.info.goodsList[0].goodsState == 'WAIT_USE'){
					
						qrCode(this.info.goodsList[0].id).then(res=>{
							this.loading = false
							if(res.state == 'Success'){
								this.codeData = res.content
							}
						})
					}
			
				})
			},
			// 取消支付
			cancel(){
				uni.showLoading({
					title: '取消中'
				})
				closeOrder(this.info.orderNo).then(res=>{
					if(res.state == 'Success'){
						uni.showToast({
							title: '取消成功',
							icon: 'success'
						})
						this.payDetails(this.info.orderNo)
					}
				})
			},
			// 支付
			pay(){
				let that = this
					if (this.btnLoading) return
					this.btnLoading = true
					uni.showLoading({
						title: '支付中'
					})
					let miniPayRequest = JSON.parse(this.info.payment.miniPayRequest)
					uni.requestPayment({
						"provider": "wxpay",
						"orderInfo": miniPayRequest,
						"appid": miniPayRequest.appId, // 微信开放平台 - 应用 - AppId，注意和微信小程序、公众号 AppId 可能不一致
						"paySign": miniPayRequest.paySign,
						"nonceStr": miniPayRequest.nonceStr, // 随机字符串
						"package": miniPayRequest.package, // 固定值
						// "prepayid":  miniPayRequest.package, // 统一下单订单号 
						"timeStamp": miniPayRequest.timeStamp, // 时间戳（单位：秒）
						"signType": miniPayRequest.signType, //签名算法
						success(msg) {
							console.log('msg', msg);
							queryPayOrder(that.info.orderNo).then(res1 => {
								if (res1.state == 'Success') {
									uni.hideLoading()
									uni.showToast({
										title: '支付成功',
										icon: 'success'
									})
									that.btnLoading = false
									that.payDetails(that.info.orderNo)
								}
							})
						},
						fail(e) {
							that.btnLoading = false
							uni.hideLoading()
							uni.showToast({
								title: '取消支付',
								icon: 'fail'
							})
							// 取消支付后，获取支付信息以备再次支付
							that.payDetails(that.info.orderNo)
							console.log('err', e,this);
						}
					})
			},
			// 取消退款申请
			cancelReply(){
				if (this.btnLoading) return
				this.btnLoading = true
				uni.showLoading({
					title: '取消中'
				})
				unRefund({id:this.info.goodsList[0].id}).then(res=>{
					this.btnLoading = false
					uni.hideLoading()
					
					if (res.state == 'Success') {
						this.payDetails(this.info.orderNo)
						uni.showToast({
							title:'取消成功',
							icon:'success'
						})
					}
				})
			}
		},
		onReady() {
			
		},
		onLoad(options) {
			this.info.orderNo = options.id
		},
		onShow() {
			this.pageLoading = true
			this.payDetails(this.info.orderNo)
		},
		created() {
			// this.info = JSON.parse(uni.getStorageSync('order'))
		}
	}
</script>

<style lang="scss">
.order-detail{
	background: #F9F9F9;
	min-height: 100vh;
	padding-bottom: 100rpx;
	.status-box{
		padding: 24rpx 24rpx 4rpx;
		display: flex;
		justify-content: space-between;
		.text-box{
			color: #181818;
			.status{
				font-weight: bold;
				font-size: 32rpx;
				display: flex;
				.u-count-down__text{
					color: $uni-color-primary!important;
				}
			}
			.notice{
				font-size: 24rpx;
				margin-top: 20rpx;
			}
		}
	}
	
	.goods-box{
		.goods-item{
			display: flex;
			align-items: center;
			justify-content: space-between;
			padding: 12rpx 0;
			.left{
				display: flex;
				align-items: center;
				.icon{
					width: 80rpx;
					height: 80rpx;
					border-radius: 16rpx 16rpx 16rpx 16rpx;
				}
				.name{
					font-size: 28rpx;
					color: #222222;
					margin-left: 20rpx;
					max-width: 400rpx;
					white-space: nowrap;
					overflow: hidden;
					text-overflow: ellipsis;
				}
				
				.num{
					font-size: 24rpx;
					color: #AAAAAA;
					margin-left: 20rpx;
				}
			}
			.right{
				font-size: 28rpx;
				color: #222222;
			}
		}
		
		.total-box{
			display: flex;
			align-items: center;
			justify-content: flex-end;
			font-size: 28rpx;
			color: #222222;
			padding-top: 24rpx;
			border-top: 1rpx solid #F0F0F0;
			.num{
				
			}
			.price{
				margin-left: 20rpx;
			}
		}
	}

	
	.shop-box{
		width: 690rpx;
		// margin: 0 30rpx;
		// padding: 24rpx 24rpx 30rpx;
		background: #fff;
		border-radius: 16rpx;
		margin-top: -30rpx;
		box-sizing: border-box;
		.shop-name{
			font-weight: 600;
			font-size: 32rpx;
			color: #181818;
			width: 100%;
			white-space: nowrap;
			overflow: hidden;
			text-overflow: ellipsis;
		}
		.address{
			font-weight: 300;
			font-size: 24rpx;
			color: #AAAAAA;
			margin-top: 20rpx;
			width: 100%;
			white-space: nowrap;
			overflow: hidden;
			text-overflow: ellipsis;
		}
	}
	
	.black{
		color: #222222!important;
	}
	
	.red{
		color: red!important;
	}
	.fs28{
		font-size: 28rpx!important;
		font-weight: bold;
	}
	
	.code-box{
	
		// .left{
		// 	.title{
		// 		font-weight: 500;
		// 		font-size: 28rpx;
		// 		color: #222222;
		// 	}
		// 	.codeNum{
		// 		font-weight: 300;
		// 		font-size: 24rpx;
		// 		color: #AAAAAA;
		// 		margin-top: 15rpx;
		// 	}
		// }
	
		.qrcode{
			display: flex;
			align-items: center;
			justify-content: center;
			margin-top: 20rpx;
		}
		.code-btn{
			display: flex;
			align-items: center;
			font-weight: 300;
			font-size: 24rpx;
			color: #AAAAAA;
			.jiantou{
				width: 24rpx;
				height: 24rpx;
			}
		}
		
	}
	
	.input-box{
		margin: 20rpx 30rpx;
		padding: 28rpx 24rpx;
		background: #FFFFFF;
		border-radius: 16rpx 16rpx 16rpx 16rpx;
		display: flex;
		align-items: center;
		justify-content: space-between;
		.label {
			color: #222;
			font-size: 28rpx;
		}
		
		.value {
			font-size: 28rpx;	
			color: #AAAAAA;
		}
	}
	
	.content{
		margin: 20rpx 30rpx;
		padding: 28rpx 24rpx;
		border-radius: 16rpx;
		background: #fff;
		.title{
			font-weight: 600;
			font-size: 28rpx;
			color: #222222;
		}
		.item{
			display: flex;
			align-items: center;
			justify-content: space-between;
			margin-top: 28rpx;
			.label{
				font-size: 28rpx;
				color: #AAAAAA;
			}
			.value{
				font-size: 28rpx;
				color: #222222;
			}
		}
	}
	.pay-btn{
		background: $uni-color-primary;
		width: 688rpx;
		height: 80rpx;
		line-height: 80rpx;
		border-radius: 46rpx;
		color: #fff;
		margin-top: 50rpx;
	}
	.refund-box{
		.refund-msg{
			font-weight: 300;
			font-size: 24rpx;
			color: #222222;
			margin-top: 15rpx;
			line-height: 40rpx;
		}
	}
	.apply-box{
		position: relative;
		.label{
			font-weight: 600;
			font-size: 28rpx;
			color: #222222;
		}
		.value{
			color: #999999;
			font-size: 24rpx;
			margin-top: 15rpx;
		}
		
		.jiantou{
			position: absolute;
			top: 50%;
			right: 24rpx;
			transform: translateY(-50%);
			width: 24rpx;
			height: 24rpx;
		}
	}
	.btn-box {
		position: fixed;
		bottom: 0%;
		left: 0%;
		width: 100%;
		display: flex;
		align-items: center;
		justify-content: flex-end;
		box-sizing: border-box;
		padding: 10rpx 24rpx env(safe-area-inset-bottom);
		background: #fff;
		border-top: 1rpx solid #EEEEEE;
		.cancel-btn{
			width: 240rpx;
			height: 80rpx;
			line-height: 80rpx;
			text-align: center;
			border-radius: 40rpx;
			border: 2rpx solid #EE4320;
			font-weight: 600;
			font-size: 28rpx;
			color: #EE4320;
			margin: 0;
		}
		.btn {
			width: 240rpx;
			height: 80rpx;
			line-height: 80rpx;
			text-align: center;
			background: $uni-color-primary;
			border-radius: 40rpx;
			font-weight: 600;
			font-size: 28rpx;
			color: #FFFFFF;
			margin: 0;
			margin-left: 20rpx;
		}
	}
	.info{
		.order-info{
			display: flex;
			.icon{
				width: 164rpx;
				height: 164rpx;
				border-radius: 16rpx;
				flex-shrink: 0;
			}
			.shop-info{
				display: flex;
				flex-direction: column;
				justify-content: space-between;
				padding-left: 24rpx;
				flex: 1;
				box-sizing: border-box;
				.title{
					color: #181818;
					font-size: 28rpx;
					width: 450rpx;
					white-space: nowrap;
					overflow: hidden;
					text-overflow: ellipsis;
				}
				.price-box{
					display: flex;
					align-items: center;
					justify-content: space-between;
					.price{
						color: #181818;
						color: $uni-color-primary;
						font-size: 32rpx;
						font-weight: bold;
					}
					
				}
				.start-time,.goods-desc{
					font-size: 24rpx;
					color: #AAAAAA;
					width: 450rpx;
					white-space: nowrap;
					overflow: hidden;
					text-overflow: ellipsis;
				}
			}
		}
		
		
	}
	
	.wrap{
		display: flex;
		justify-content: center;
		align-items: center;
		height: 100vh;
		overflow: hidden;
	}
	
}
</style>